// ShmMgr.h: interface for the CShmLogClient class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
#define AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CShmLogClient  
{
public:
	void ProcessLogs();
	virtual ~CShmLogClient();

	static CShmLogClient* CreateClient(PVOID addr, ULONG size, std::string& strPrefix);

	virtual void Delete()	{delete this;	}
	inline operator bool () const {return m_bIsValid;}

	//
	// OPERATIONS
	//
	
	bool WriteString (std::vector<char>& data);
	bool WriteString (const char* data);


private:

//
// Client side constructor
//
	CShmLogClient(PVOID MemoryAddress, 
			ULONG MemorySize,
			std::string& KeyPrefix);

	CShmLogClient()
	{
		//
		// We should not use the defulat constructor
		//
		  throw std::exception("CShmLogClient default constructor is not allowed");
	}

  	bool WriteToBuffer(std::vector<char>& data, 
						bool bFragmented=false, 
						bool endFragment=true);
	
  	bool WriteToBuffer(const char* data, 
						bool bFragmented=false, 
						bool endFragment=true);
	
 
	LOGBUFFER*		m_ShmBuffer;
	ULONG			m_MaxSize;
	bool			m_bIsValid;



	CMclSemaphoreAutoPtr	m_LogEntrySemPtr;
	CMclSemaphoreAutoPtr	m_LogSpaceSemPtr;
	CMclEvent				m_StopNotify;
	CMclEvent				m_StopAck;
	std::string				m_strKeyPrefix;


 
};

#endif // !defined(AFX_SHMMGR_LOGGER_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
