// ShmMgr.cpp: implementation of the CShmMgrClient class.
//
//////////////////////////////////////////////////////////////////////
//
// PROJECT INCLUDE
//
#include "stdafx.h"
#include "ShmMgrClient.h"
#include <sstream>
using namespace std;
 
 
 
//////////////////////////////////////////////////////////////////////////////
//
//	SHM Manager code
//
//

CShmMgrClient * CShmMgrClient::m_ClientInstance=NULL;



CShmMgrClient& CShmMgrClient::ClientInstance()
{
	if(!m_ClientInstance) 
	{
		m_ClientInstance=new CShmMgrClient();
	}
	return *m_ClientInstance;
}

void CShmMgrClient::CleanupClientInstance()
{
	delete m_ClientInstance;
}



CShmMgrClient::CShmMgrClient():m_hFileMap(NULL),m_pView(NULL)
{
	m_bIsValid=false;
	m_size=LOGBUFFER_SIZE;
	
 		m_hFileMap=OpenFileMapping(FILE_MAP_READ|FILE_MAP_WRITE,
										FALSE,
										TEXT(MAGIC_STRING));

		if (m_hFileMap!=NULL)
		{
			m_pView= MapViewOfFile(m_hFileMap,
										FILE_MAP_READ|FILE_MAP_WRITE,
										0,
										0,
										0);

			m_bIsValid=m_pView!=NULL;
		}
		else
		{
			ostringstream os;
			os<<"Fail to open the shared memory:"<<GetLastError()<<endl;
			OutputDebugStringA(os.str().c_str());
		}
 
}

CShmMgrClient::~CShmMgrClient()
{
	if (m_pView)
	{
		UnmapViewOfFile(m_pView);
	}

	if (m_hFileMap)
	{
		CloseHandle(m_hFileMap);
	}
}


