// ShmMgr.h: interface for the CShmLogMgr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHMMGR_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
#define AFX_SHMMGR_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



//
// The class request the shared memory and partition the memory
//

struct SHMBLOCK 
{
	PVOID m_address;
	ULONG m_size;

	SHMBLOCK(PVOID a=NULL, ULONG size=0):m_address(a),m_size(size){}

};

class CShmMgrClient
{
public:
	~CShmMgrClient();

 
 	static CShmMgrClient& ClientInstance();

 	static void CleanupClientInstance();

	 
	operator bool() const { 
		
		return m_bIsValid;
	}

	SHMBLOCK GetDebugLogBlock()
	{
		if (m_bIsValid)
		{
			return SHMBLOCK(m_pView,m_size/BLOCK_NUMBER);
		}
		return SHMBLOCK();
	}

	SHMBLOCK GetPacketsLogBlock()
	{
		if (m_bIsValid)
		{
			return SHMBLOCK((char*)m_pView+m_size/BLOCK_NUMBER,
							m_size/BLOCK_NUMBER);
		}
		return SHMBLOCK();
	}

	SHMBLOCK GetTrafficLogBlock()
	{
		if (m_bIsValid)
		{
			return SHMBLOCK((char*)m_pView+(m_size/BLOCK_NUMBER)*2,
					m_size/BLOCK_NUMBER);
		}
		return SHMBLOCK();
	} 

	SHMBLOCK GetProtectionLogBlock()
	{
		if (m_bIsValid)
		{
			return SHMBLOCK((char*)m_pView+(m_size/BLOCK_NUMBER)*3,
					m_size/BLOCK_NUMBER);
		}
		return SHMBLOCK();
	}



private:
	CShmMgrClient();

	HANDLE m_hFileMap;
	PVOID  m_pView;
	bool	m_bIsValid;
	ULONG  m_size;

	static CShmMgrClient * m_ServerInstance;
	static CShmMgrClient * m_ClientInstance;

	

};






#endif // !defined(AFX_SHMMGR_H__D6FD0559_46F1_4D99_8996_9538EF2A0EFA__INCLUDED_)
