// FragmentStringTable.cpp: implementation of the CFragStringTable class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FragmentStringTable.h"
 
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFragStringTable::CFragStringTable()
{
	m_intStartHandle=-1;
}

CFragStringTable::~CFragStringTable()
{
	m_FragStringTable.clear();
}

CFragStringTable& CFragStringTable::Instance_DebugLog()
{
	static CFragStringTable obj;
	return obj;
}
CFragStringTable& CFragStringTable::Instance_PacketsLog()
{
	static CFragStringTable obj;
	return obj;
}
CFragStringTable& CFragStringTable::Instance_TrafficLog()
{
	static CFragStringTable obj;
	return obj;
}
CFragStringTable& CFragStringTable::Instance_Protectionlog()
{
	static CFragStringTable obj;
	return obj;
}

bool CFragStringTable::Register(ULONG id)
{
	std::map<ULONG, std::string>::iterator it=m_FragStringTable.find(id);

	if(it!=m_FragStringTable.end())
	{
		m_FragStringTable.erase(id);

	}
	m_FragStringTable[id]=std::string();
	return true;
}

bool CFragStringTable::Unregister(ULONG id)
{
	 m_FragStringTable.erase(id);
	return true;
}

bool CFragStringTable::AddString (ULONG id, const char* str)
{
	std::map<ULONG, std::string>::iterator it=m_FragStringTable.find(id);

	if(it!=m_FragStringTable.end())
	{
		int size=strlen(str)+m_FragStringTable[id].size();
		if (MAX_STRING_SIZE>=size)
		{
			m_FragStringTable[id]+=str;
			return true;
		}
 
	}
	return false;
}

bool CFragStringTable::AddString (ULONG id, const char* str, int size)
{
	std::map<ULONG, std::string>::iterator it=m_FragStringTable.find(id);

	string s;
	if(it!=m_FragStringTable.end())
	{
		int nextSize=size+m_FragStringTable[id].size();
		if (MAX_STRING_SIZE>=nextSize)
		{
			s.resize(size);
			for (int i=0; i<size;i++)
			{
				s[i]=str[i];
			}

			if (str[s.size()-1]!='\0')
			{
				s+='\0';
				
			}

			m_FragStringTable[id]+=s.c_str();
			return true;
		}
	}
	return false;
}


bool CFragStringTable::GetString(ULONG id,std::vector<char>& retString)
{
	std::map<ULONG, std::string>::iterator it=m_FragStringTable.find(id);

	if(it!=m_FragStringTable.end())
	{
		if(!m_FragStringTable[id].empty())
		{
			retString.resize(m_FragStringTable[id].size());
			std::copy(m_FragStringTable[id].begin(),
					  m_FragStringTable[id].end(),
					  retString.begin());
			retString.push_back('\0');

			m_FragStringTable[id]="";

			 
			return true;
		}
	}
	return false;
}


