//
// FILE                  : LOG_DEF.h
//
//
// REVISION HISTORY: [10/18/2004] 
//
// CREATED BY:             
// 
// DESCRIPTION:
//
//

#ifndef _LOG_DEF_10_18_2004_H
#define _LOG_DEF_10_18_2004_H

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//

// LOCAL INCLUDES
//

// LOCAL MACROS
//

// EXPORTED GLOBOL VARIABLES
//

// FORWARD REFERENCES
//
#define LOGENTRY_STRING_SIZE 20			// Length of allowable strings in log entries
#define LOGBUFFER_SIZE 0x4000				// MUST BE A POWER OF TWO. This is so that write count correctly wraps
											// if it ever goes over 0xffffffff.

#define BLOCK_NUMBER   4
typedef struct _LOGBUFFER
{
	unsigned long		ulSig;			// "beef"
	long count;							// Amount of data currently in buffer
	long write;							// write count - this increments but is never reset
	long read;							// The size of the ring buffer (should be <=LOGBUFFER_SIZE)
	long MaxCount;						// how many entries? This equals RINGBUFFER_ENTRIES and never changes
	char buffer[1];						// Our actual buffer size should be less than LOGBUFFER_SIZE

}LOGBUFFER;


typedef struct _LOG_ENTRY
{
	WORD	size;						// Size include the header should be less than LOGBUFFER_SIZE
	BYTE	flag;						// 0x80 - fragmented; 0x40 fragement is not end
	BYTE	reserve;
	ULONG	Handle;
	char buffer[1];						// Our actual buffer
}
LOG_ENTRY,*PLOG_ENTRY;

#define HeaderSize			((ULONG) (((LOGBUFFER*)0)->buffer))
#define EntryHeaderSize		((ULONG) (((LOG_ENTRY*)0)->buffer))
#define EntryPayloadSize	(LOGENTRY_STRING_SIZE-((ULONG) (((LOG_ENTRY*)0)->buffer)))

#define MAGIC_STRING			"{FB2230F3-3ED5-4f9a-82F2-93D29CCE8298}"
#define MAGIC_STRING_DEBUG		"{559609B8-62F7-4279-8249-82B04CDE801C}"

#define SEMAPHOE_POSTFIX_PRODUCT "Semaphore Product"
#define SEMAPHOE_POSTFIX_AVAIL "Semaphore AVAIL"

#endif  //_LOG_DEF_10_18_2004_H
