// ServerSecurityAttribute.cpp: implementation of the CServerSecurityAttribute class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ServerSecurityAttribute.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CServerSecurityAttribute::CServerSecurityAttribute()
{
}

void CServerSecurityAttribute::Create()
{
	m_bValid=false;
	m_Dacl.Create();

	ZeroMemory( &m_SecurityAttributes, sizeof(m_SecurityAttributes) );
    m_SecurityAttributes.nLength = sizeof( m_SecurityAttributes );
    m_SecurityAttributes.bInheritHandle = FALSE; // object uninheritable

   // declare and initialize a security descriptor
   BOOL bInitOk = InitializeSecurityDescriptor( &m_SD,
                           SECURITY_DESCRIPTOR_REVISION );
   if ( bInitOk )
   {
      // assign the dacl to it
      BOOL ret = SetSecurityDescriptorDacl( &m_SD,
                                            TRUE,
                                             m_Dacl.GetPDACL(),
                                              FALSE );
      if ( ret )
      {
         // Make the security attributes point to 
         //the security descriptor
         m_SecurityAttributes.lpSecurityDescriptor = &m_SD;
		 m_bValid=true;
	  }
   }
}

void CServerSecurityAttribute::CreateNULL()
{
	m_bValid=false;
 
	ZeroMemory( &m_SecurityAttributes, sizeof(m_SecurityAttributes) );
    m_SecurityAttributes.nLength = sizeof( m_SecurityAttributes );
    m_SecurityAttributes.bInheritHandle = FALSE; // object uninheritable

   // declare and initialize a security descriptor
   BOOL bInitOk = InitializeSecurityDescriptor( &m_SD,
                           SECURITY_DESCRIPTOR_REVISION );
   if ( bInitOk )
   {
      // assign the dacl to it
      BOOL ret = SetSecurityDescriptorDacl( &m_SD,
                                            TRUE,
                                            (PACL)NULL,
                                            FALSE );
      if ( ret )
      {
         // Make the security attributes point to 
         //the security descriptor
         m_SecurityAttributes.lpSecurityDescriptor = &m_SD;
		 m_bValid=true;
	  }
   }
}

SECURITY_ATTRIBUTES* CServerSecurityAttribute::GetNewsSecurityAttribute()
{
	return &m_SecurityAttributes;
}

CServerSecurityAttribute::~CServerSecurityAttribute()
{

}

CServerSecurityAttribute& CServerSecurityAttribute::NotQuitNullOne()
{
	static CServerSecurityAttribute obj;
	obj.Create();
	return obj;
}

CServerSecurityAttribute& CServerSecurityAttribute::RealNullOne()
{
	static CServerSecurityAttribute obj;
	obj.CreateNULL();
	return obj;
}

 